const std = @import("std");
const CrossTarget = std.zig.CrossTarget;
const Build = std.build.Builder;
const Step = Build.Step;

pub fn build(b: *Build) void {
    const mode = b.standardOptimizeOption(.{});

    const lib86 = b.addSharedLibrary(Build.SharedLibraryOptions{
        .name = "chuniio_tasoller",
        .root_source_file = .{.path = "src/main.zig"},
        .target = CrossTarget{ .os_tag = .windows, .cpu_arch = .x86, .abi = .msvc },
        .optimize = mode,
    });
    b.installArtifact(lib86);

    const lib64 = b.addSharedLibrary(Build.SharedLibraryOptions{
        .name = "chuniio_tasoller_x64",
        .root_source_file = .{.path = "src/main.zig"},
        .target = CrossTarget{ .os_tag = .windows, .cpu_arch = .x86_64, .abi = .msvc },
        .optimize = mode,
    });
    b.installArtifact(lib64);
}